﻿package  
{
	import flash.display.DisplayObjectContainer;
	
	public class SortZ 
	{
		private var container:DisplayObjectContainer;
		private var obj3ds:Array;
		
		public function SortZ(container:DisplayObjectContainer)
		{
			this.container = container;
			resetContainer();
		}
		
		public function setContainer(container:DisplayObjectContainer):void
		{
			this.container = container;
			resetContainer();
		}
		
		private function resetContainer():void
		{
			obj3ds = new Array();
			var i:int;
			var len:int = container.numChildren;
			var obj:Object3D;
			for (i = 0; i < len; i++) {
				obj = new Object3D(container.getChildAt(i));
				obj3ds[i] = obj;
			}
		}
		
		public function update():void
		{
			var i:int;
			var len:int = obj3ds.length;
			var obj:Object3D;
			for (i = 0; i < len; i++) {
				obj = obj3ds[i];
				obj.updateZ();
			}
			obj3ds.sortOn("z", Array.DESCENDING | Array.NUMERIC);
			for (i = 0; i < len; i++) {
				container.setChildIndex(obj3ds[i].obj, i);
			}
		}
	}
	
}
import flash.display.DisplayObject;
import flash.geom.Matrix3D;

class Object3D {
	public var z:Number;
	public var obj:DisplayObject;
	
	public function Object3D(obj:DisplayObject) {
		this.obj = obj;
	}
	
	public function updateZ():void
	{
		var mt3:Matrix3D = obj.transform.getRelativeMatrix3D(obj.root);
		z = mt3.position.z;
	}
}